import datetime
from functools import singledispatch
from src.models.abstract_reference import abstract_reference
from src.convert.basic_converter import basic_converter
from src.convert.datetime_converter import datetime_converter
from src.convert.model_converter import model_converter


class converter_factory:
    @singledispatch
    @staticmethod
    def create(obj):
        return basic_converter()

    @create.register
    def create_model(obj: abstract_reference):
        return model_converter()

    @create.register
    def create_datetime(obj: datetime.datetime):
        return datetime_converter()
